Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Two_Level_Branch_Predictor.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Two_Level_Branch_Predictor.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Two_Level_Branch_Predictor.cpp	(revision 131)
@@ -72,16 +72,16 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-        // Constants :
-        for (uint32_t i=0; i<_param->_nb_inst_predict; ++i)
-          {
-            internal_PREDICT_ACK [i] = 1;
-            PORT_WRITE(out_PREDICT_ACK [i], internal_PREDICT_ACK [i]);
-          }
-        for (uint32_t i=0; i<_param->_nb_inst_update; ++i)
-          {
-            internal_UPDATE_ACK [i] = 1;
-            PORT_WRITE(out_UPDATE_ACK [i], internal_UPDATE_ACK [i]);
-          }
-        
+#ifdef SYSTEMCASS_SPECIFIC
+        constant();
+#else
+	log_printf(INFO,Two_Level_Branch_Predictor,FUNCTION,_("<%s> : Method - constant"),_name.c_str());
+
+	SC_METHOD (constant);
+// 	dont_initialize ();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+#endif
 
 	log_printf(INFO,Two_Level_Branch_Predictor,FUNCTION,_("<%s> : Method - transition"),_name.c_str());
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Two_Level_Branch_Predictor_constant.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Two_Level_Branch_Predictor_constant.cpp	(revision 131)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/src/Two_Level_Branch_Predictor_constant.cpp	(revision 131)
@@ -0,0 +1,53 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/include/Two_Level_Branch_Predictor.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace direction {
+namespace meta_predictor {
+namespace two_level_branch_predictor {
+
+
+#undef  FUNCTION
+#define FUNCTION "Two_Level_Branch_Predictor::constant"
+  void Two_Level_Branch_Predictor::constant (void)
+  {
+    log_begin(Two_Level_Branch_Predictor,FUNCTION);
+    log_function(Two_Level_Branch_Predictor,FUNCTION,_name.c_str());
+
+    for (uint32_t i=0; i<_param->_nb_inst_predict; ++i)
+      {
+        internal_PREDICT_ACK [i] = 1;
+        PORT_WRITE(out_PREDICT_ACK [i], internal_PREDICT_ACK [i]);
+      }
+    for (uint32_t i=0; i<_param->_nb_inst_update; ++i)
+      {
+        internal_UPDATE_ACK [i] = 1;
+        PORT_WRITE(out_UPDATE_ACK [i], internal_UPDATE_ACK [i]);
+      }
+
+    log_end(Two_Level_Branch_Predictor,FUNCTION);
+  };
+
+}; // end namespace two_level_branch_predictor
+}; // end namespace meta_predictor
+}; // end namespace direction
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/include/Return_Address_Stack.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/include/Return_Address_Stack.h	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/include/Return_Address_Stack.h	(revision 131)
@@ -143,4 +143,5 @@
 					       
 #ifdef SYSTEMC				       
+  public  : void        constant                  (void);
   public  : void        transition                (void);
   public  : void        genMealy_predict          (void);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack.cpp	(revision 131)
@@ -74,20 +74,16 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-    	for (uint32_t i=0; i<_param->_nb_inst_predict; i++)
-	  {
-	    internal_PREDICT_ACK [i] = 1;
-	    PORT_WRITE(out_PREDICT_ACK [i], internal_PREDICT_ACK [i]);
-	  }
-    	for (uint32_t i=0; i<_param->_nb_inst_decod  ; i++)
-	  {
-	    internal_DECOD_ACK   [i] = 1;
-	    PORT_WRITE(out_DECOD_ACK   [i], internal_DECOD_ACK   [i]);
-	  }
-    	for (uint32_t i=0; i<_param->_nb_inst_update ; i++)
-	  {
-	    internal_UPDATE_ACK  [i] = 1;
-	    PORT_WRITE(out_UPDATE_ACK  [i], internal_UPDATE_ACK  [i]);
-	  }
+#ifdef SYSTEMCASS_SPECIFIC
+        constant();
+#else
+	log_printf(INFO,Return_Address_Stack,FUNCTION,"Method - constant");
 
+	SC_METHOD (constant);
+// 	dont_initialize ();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+#endif
 	log_printf(INFO,Return_Address_Stack,FUNCTION,"Method - transition");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_constant.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_constant.cpp	(revision 131)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_constant.cpp	(revision 131)
@@ -0,0 +1,54 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/include/Return_Address_Stack.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace return_address_stack {
+
+
+#undef  FUNCTION
+#define FUNCTION "Return_Address_Stack::constant"
+  void Return_Address_Stack::constant (void)
+  {
+    log_begin(Return_Address_Stack,FUNCTION);
+    log_function(Return_Address_Stack,FUNCTION,_name.c_str());
+
+    	for (uint32_t i=0; i<_param->_nb_inst_predict; i++)
+	  {
+	    internal_PREDICT_ACK [i] = 1;
+	    PORT_WRITE(out_PREDICT_ACK [i], internal_PREDICT_ACK [i]);
+	  }
+    	for (uint32_t i=0; i<_param->_nb_inst_decod  ; i++)
+	  {
+	    internal_DECOD_ACK   [i] = 1;
+	    PORT_WRITE(out_DECOD_ACK   [i], internal_DECOD_ACK   [i]);
+	  }
+    	for (uint32_t i=0; i<_param->_nb_inst_update ; i++)
+	  {
+	    internal_UPDATE_ACK  [i] = 1;
+	    PORT_WRITE(out_UPDATE_ACK  [i], internal_UPDATE_ACK  [i]);
+	  }
+
+    log_end(Return_Address_Stack,FUNCTION);
+  };
+
+}; // end namespace return_address_stack
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h	(revision 131)
@@ -254,4 +254,5 @@
 					       
 #ifdef SYSTEMC				       
+  public  : void        constant                  (void);
   public  : void        transition                (void);
   public  : void        genMoore                  (void);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table.cpp	(revision 131)
@@ -76,16 +76,16 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-        // Constant
-	for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
-	  {
-	    internal_BRANCH_COMPLETE_ACK [i] = 1;
-	    PORT_WRITE(out_BRANCH_COMPLETE_ACK [i], internal_BRANCH_COMPLETE_ACK [i]);
-	  }
-        for (uint32_t i=0; i<_param->_nb_context; ++i)
-          {
-            internal_EVENT_ACK [i] = 1;
-            PORT_WRITE(out_EVENT_ACK [i], internal_EVENT_ACK [i]);
-          }
-
+#ifdef SYSTEMCASS_SPECIFIC
+        constant();
+#else
+	log_printf(INFO,Update_Prediction_Table,FUNCTION,"Method - constant");
+
+	SC_METHOD (constant);
+// 	dont_initialize ();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+#endif
 	log_printf(INFO,Update_Prediction_Table,FUNCTION,"Method - transition");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_constant.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_constant.cpp	(revision 131)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_constant.cpp	(revision 131)
@@ -0,0 +1,48 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace update_prediction_table {
+
+#undef  FUNCTION
+#define FUNCTION "Update_Prediction_Table::constant"
+  void Update_Prediction_Table::constant (void)
+  {
+    log_begin(Update_Prediction_Table,FUNCTION);
+    log_function(Update_Prediction_Table,FUNCTION,_name.c_str());
+
+    for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
+      {
+        internal_BRANCH_COMPLETE_ACK [i] = 1;
+        PORT_WRITE(out_BRANCH_COMPLETE_ACK [i], internal_BRANCH_COMPLETE_ACK [i]);
+      }
+    for (uint32_t i=0; i<_param->_nb_context; ++i)
+      {
+        internal_EVENT_ACK [i] = 1;
+        PORT_WRITE(out_EVENT_ACK [i], internal_EVENT_ACK [i]);
+      }
+
+    log_end(Update_Prediction_Table,FUNCTION);
+  };
+
+}; // end namespace update_prediction_table
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/test.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/test.cpp	(revision 131)
@@ -67,4 +67,5 @@
   sc_signal<Toperation_t         >  ** out_DECOD_OPERATION                ;
   sc_signal<Tcontrol_t           >  ** out_DECOD_NO_EXECUTE               ;
+  sc_signal<Tcontrol_t           >  ** out_DECOD_LAST_EVENT               ;
   sc_signal<Tcontrol_t           >  ** out_DECOD_IS_DELAY_SLOT            ;
   sc_signal<Tgeneral_data_t      >  ** out_DECOD_ADDRESS                  ;
@@ -144,4 +145,5 @@
   ALLOC1_SC_SIGNAL(out_DECOD_OPERATION                ,"out_DECOD_OPERATION                ",Toperation_t         ,_param->_sum_inst_decod);
   ALLOC1_SC_SIGNAL(out_DECOD_NO_EXECUTE               ,"out_DECOD_NO_EXECUTE               ",Tcontrol_t           ,_param->_sum_inst_decod);
+  ALLOC1_SC_SIGNAL(out_DECOD_LAST_EVENT               ,"out_DECOD_LAST_EVENT               ",Tcontrol_t           ,_param->_sum_inst_decod);
   ALLOC1_SC_SIGNAL(out_DECOD_IS_DELAY_SLOT            ,"out_DECOD_IS_DELAY_SLOT            ",Tcontrol_t           ,_param->_sum_inst_decod);
   ALLOC1_SC_SIGNAL(out_DECOD_ADDRESS                  ,"out_DECOD_ADDRESS                  ",Tgeneral_data_t      ,_param->_sum_inst_decod);
@@ -234,4 +236,5 @@
   INSTANCE1_SC_SIGNAL(_Front_end,out_DECOD_OPERATION                ,_param->_sum_inst_decod);
   INSTANCE1_SC_SIGNAL(_Front_end,out_DECOD_NO_EXECUTE               ,_param->_sum_inst_decod);
+  INSTANCE1_SC_SIGNAL(_Front_end,out_DECOD_LAST_EVENT               ,_param->_sum_inst_decod);
   INSTANCE1_SC_SIGNAL(_Front_end,out_DECOD_IS_DELAY_SLOT            ,_param->_sum_inst_decod);
 #ifdef DEBUG
@@ -319,38 +322,38 @@
   LABEL("Initialisation");
 
-  for (uint32_t i=0; i<_param->_nb_context; ++i)
-    {
-      in_ICACHE_REQ_ACK     [i]->write(0);
-      in_ICACHE_RSP_VAL     [i]->write(0);
-      in_EVENT_ACK          [i]->write(0);
-      in_SPR_EVENT_ACK      [i]->write(0);
-      in_NB_INST_COMMIT_ALL [i]->write(0); // no inst
-      in_NB_INST_COMMIT_MEM [i]->write(0); // no inst
-      in_SPR_SR_IEE         [i]->write(0); // interrupt disable
-      in_SPR_SR_EPH         [i]->write(0); // exception msb = 0
-      in_INTERRUPT_ENABLE   [i]->write(0); // no interrupt
-    }
-  for (uint32_t i=0; i<_param->_sum_inst_decod; ++i)
-    in_DECOD_ACK [i]->write(0);
-  for (uint32_t i=0; i<_param->_nb_inst_branch_complete; ++i)
-    in_BRANCH_COMPLETE_VAL [i]->write(0);
-  in_COMMIT_EVENT_VAL->write(0);
-
-
-  for (uint32_t i=0; i<_param->_nb_context; ++i)
-    {
-      TEST(Tcontrol_t,out_ICACHE_REQ_VAL      [i]->read(),0);
-      TEST(Tcontrol_t,out_ICACHE_RSP_ACK      [i]->read(),1); // Can accept a respons
-      TEST(Tcontrol_t,out_EVENT_VAL           [i]->read(),0); 
-      TEST(Tcontrol_t,out_SPR_EVENT_VAL       [i]->read(),0);
-      TEST(Tdepth_t  ,out_DEPTH_MIN           [i]->read(),0); // no branch speculated
-      TEST(Tdepth_t  ,out_DEPTH_MAX           [i]->read(),0); // no branch speculated
-      TEST(Tdepth_t  ,out_DEPTH_FULL          [i]->read(),0); // no branch speculated
-    }
-  for (uint32_t i=0; i<_param->_sum_inst_decod; ++i)
-  TEST(Tcontrol_t,out_DECOD_VAL           [i]->read(),0);
-  for (uint32_t i=0; i<_param->_nb_inst_branch_complete; ++i)
-  TEST(Tcontrol_t,out_BRANCH_COMPLETE_ACK [i]->read(),0); // can't accept (interactive)
-  TEST(Tcontrol_t,out_COMMIT_EVENT_ACK       ->read(),1); // can accept
+//   for (uint32_t i=0; i<_param->_nb_context; ++i)
+//     {
+//       in_ICACHE_REQ_ACK     [i]->write(0);
+//       in_ICACHE_RSP_VAL     [i]->write(0);
+//       in_EVENT_ACK          [i]->write(0);
+//       in_SPR_EVENT_ACK      [i]->write(0);
+//       in_NB_INST_COMMIT_ALL [i]->write(0); // no inst
+//       in_NB_INST_COMMIT_MEM [i]->write(0); // no inst
+//       in_SPR_SR_IEE         [i]->write(0); // interrupt disable
+//       in_SPR_SR_EPH         [i]->write(0); // exception msb = 0
+//       in_INTERRUPT_ENABLE   [i]->write(0); // no interrupt
+//     }
+//   for (uint32_t i=0; i<_param->_sum_inst_decod; ++i)
+//     in_DECOD_ACK [i]->write(0);
+//   for (uint32_t i=0; i<_param->_nb_inst_branch_complete; ++i)
+//     in_BRANCH_COMPLETE_VAL [i]->write(0);
+//   in_COMMIT_EVENT_VAL->write(0);
+
+
+//   for (uint32_t i=0; i<_param->_nb_context; ++i)
+//     {
+//       TEST(Tcontrol_t,out_ICACHE_REQ_VAL      [i]->read(),0);
+//       TEST(Tcontrol_t,out_ICACHE_RSP_ACK      [i]->read(),1); // Can accept a respons
+//       TEST(Tcontrol_t,out_EVENT_VAL           [i]->read(),0); 
+//       TEST(Tcontrol_t,out_SPR_EVENT_VAL       [i]->read(),0);
+//       TEST(Tdepth_t  ,out_DEPTH_MIN           [i]->read(),0); // no branch speculated
+//       TEST(Tdepth_t  ,out_DEPTH_MAX           [i]->read(),0); // no branch speculated
+//       TEST(Tdepth_t  ,out_DEPTH_FULL          [i]->read(),0); // no branch speculated
+//     }
+//   for (uint32_t i=0; i<_param->_sum_inst_decod; ++i)
+//   TEST(Tcontrol_t,out_DECOD_VAL           [i]->read(),0);
+//   for (uint32_t i=0; i<_param->_nb_inst_branch_complete; ++i)
+//   TEST(Tcontrol_t,out_BRANCH_COMPLETE_ACK [i]->read(),0); // can't accept (interactive)
+//   TEST(Tcontrol_t,out_COMMIT_EVENT_ACK       ->read(),1); // can accept
 
   LABEL("Reset");
@@ -361,5 +364,5 @@
   LABEL("Loop of Test");
 
-  for (uint32_t iteration=0; iteration<NB_ITERATION; iteration ++)
+  for (uint32_t iteration=0; iteration< NB_ITERATION; iteration ++)
     {
       LABEL("Iteration %d",iteration);
@@ -399,4 +402,5 @@
   DELETE1_SC_SIGNAL(out_DECOD_OPERATION                ,_param->_sum_inst_decod);
   DELETE1_SC_SIGNAL(out_DECOD_NO_EXECUTE               ,_param->_sum_inst_decod);
+  DELETE1_SC_SIGNAL(out_DECOD_LAST_EVENT               ,_param->_sum_inst_decod);
   DELETE1_SC_SIGNAL(out_DECOD_IS_DELAY_SLOT            ,_param->_sum_inst_decod);
   DELETE1_SC_SIGNAL(out_DECOD_ADDRESS                  ,_param->_sum_inst_decod);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h	(revision 131)
@@ -338,4 +338,5 @@
 					       
 #ifdef SYSTEMC				       
+  public  : void        constant                  (void);
   public  : void        transition                (void);
   public  : void        genMoore                  (void);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit.cpp	(revision 131)
@@ -76,14 +76,16 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-        // Constant
-	for (uint32_t i=0; i<_param->_nb_front_end; i++)
-	  for (uint32_t j=0; j<_param->_nb_context [i]; j++)
-	    {
-              internal_EVENT_ACK [i][j] = 1;
-              PORT_WRITE(out_EVENT_ACK [i][j], internal_EVENT_ACK [i][j]);
-
-              internal_RETIRE_EVENT_VAL [i][j] = 1;
-              PORT_WRITE(out_RETIRE_EVENT_VAL [i][j], internal_RETIRE_EVENT_VAL [i][j]);
-            }
+#ifdef SYSTEMCASS_SPECIFIC
+        constant();
+#else
+	log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Method - constant"),_name.c_str());
+
+	SC_METHOD (constant);
+// 	dont_initialize ();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+#endif
 
 	log_printf(INFO,Commit_unit,FUNCTION,_("<%s> Method - transition"),_name.c_str());
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_constant.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_constant.cpp	(revision 131)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_constant.cpp	(revision 131)
@@ -0,0 +1,46 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h"
+#include "Behavioural/include/Simulation.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace commit_unit {
+  
+#undef  FUNCTION
+#define FUNCTION "Commit_unit::constant"
+  void Commit_unit::constant (void)
+  {
+    log_begin(Commit_unit,FUNCTION);
+    log_function(Commit_unit,FUNCTION,_name.c_str());
+
+    for (uint32_t i=0; i<_param->_nb_front_end; i++)
+      for (uint32_t j=0; j<_param->_nb_context [i]; j++)
+        {
+          internal_EVENT_ACK [i][j] = 1;
+          PORT_WRITE(out_EVENT_ACK [i][j], internal_EVENT_ACK [i][j]);
+          
+          internal_RETIRE_EVENT_VAL [i][j] = 1;
+          PORT_WRITE(out_RETIRE_EVENT_VAL [i][j], internal_RETIRE_EVENT_VAL [i][j]);
+        }
+
+    log_end(Commit_unit,FUNCTION);
+  };
+
+}; // end namespace commit_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h	(revision 131)
@@ -199,4 +199,5 @@
   private : bool        must_reexecute            (Tspr_address_t address, info_t & info);
 
+  public  : void        constant                  (void);
   public  : void        transition                (void);
   public  : void        genMoore                  (void);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit.cpp	(revision 131)
@@ -75,19 +75,16 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-	// Constant
-	for (uint32_t i=0; i<_param->_nb_inst_reexecute; ++i)
-	  {
-	    if (_param->_have_port_load_queue_ptr)
-	    PORT_WRITE(out_REEXECUTE_LOAD_QUEUE_PTR_WRITE [i],0);
-	    PORT_WRITE(out_REEXECUTE_READ_RA              [i],0);
-	    PORT_WRITE(out_REEXECUTE_NUM_REG_RA           [i],0);
-	    PORT_WRITE(out_REEXECUTE_READ_RB              [i],0);
-	    PORT_WRITE(out_REEXECUTE_NUM_REG_RB           [i],0);
-	    PORT_WRITE(out_REEXECUTE_READ_RC              [i],0);
-	    PORT_WRITE(out_REEXECUTE_NUM_REG_RC           [i],0);
-	    PORT_WRITE(out_REEXECUTE_WRITE_RE             [i],0);
-	    PORT_WRITE(out_REEXECUTE_NUM_REG_RE           [i],0);
-	  }
+#ifdef SYSTEMCASS_SPECIFIC
+        constant();
+#else
+	log_printf(INFO,Reexecute_unit,FUNCTION,_("<%s> : Method - constant"),_name.c_str());
 
+	SC_METHOD (constant);
+// 	dont_initialize ();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+#endif
 
 	log_printf(INFO,Reexecute_unit,FUNCTION,_("<%s> : Method - transition"),_name.c_str());
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_constant.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_constant.cpp	(revision 131)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_constant.cpp	(revision 131)
@@ -0,0 +1,50 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::constant"
+  void Reexecute_unit::constant (void)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+    log_function(Reexecute_unit,FUNCTION,_name.c_str());
+
+    for (uint32_t i=0; i<_param->_nb_inst_reexecute; ++i)
+      {
+        if (_param->_have_port_load_queue_ptr)
+        PORT_WRITE(out_REEXECUTE_LOAD_QUEUE_PTR_WRITE [i],0);
+        PORT_WRITE(out_REEXECUTE_READ_RA              [i],0);
+        PORT_WRITE(out_REEXECUTE_NUM_REG_RA           [i],0);
+        PORT_WRITE(out_REEXECUTE_READ_RB              [i],0);
+        PORT_WRITE(out_REEXECUTE_NUM_REG_RB           [i],0);
+        PORT_WRITE(out_REEXECUTE_READ_RC              [i],0);
+        PORT_WRITE(out_REEXECUTE_NUM_REG_RC           [i],0);
+        PORT_WRITE(out_REEXECUTE_WRITE_RE             [i],0);
+        PORT_WRITE(out_REEXECUTE_NUM_REG_RE           [i],0);
+      }
+
+    log_end(Reexecute_unit,FUNCTION);
+  };
+
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMealy_commit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMealy_commit.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMealy_commit.cpp	(revision 131)
@@ -131,4 +131,7 @@
     else
       {
+        for (uint32_t i=0; i<_param->_nb_bank; i++)
+          internal_QUEUE_PUSH [i] = 0;
+
 #ifdef STATISTICS
         for (uint32_t i=0; i<_param->_nb_inst_commit; ++i)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_transition.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_transition.cpp	(revision 131)
@@ -49,5 +49,7 @@
 	      uint32_t y = internal_QUEUE_NUM_INST_EXECUTE [i];
 	      uint32_t z = internal_QUEUE_NUM_INST_COMMIT  [i];
-	      
+
+              log_printf(TRACE,Reexecute_unit,FUNCTION,"  * EXECUTE_LOOP[%d][%d] - COMMIT[%d]",x,y,z);
+
 	      entry->state        = STATE_SPR_ACCESS;
 	      entry->context_id   = (_param->_have_port_context_id  )?PORT_READ(in_EXECUTE_LOOP_CONTEXT_ID   [x][y]):0;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Load_Store_pointer_unit/include/Load_Store_pointer_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Load_Store_pointer_unit/include/Load_Store_pointer_unit.h	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Load_Store_pointer_unit/include/Load_Store_pointer_unit.h	(revision 131)
@@ -146,4 +146,5 @@
 					       
 #ifdef SYSTEMC				       
+  public  : void        constant                 (void);
   public  : void        transition                (void);
   public  : void        genMealy_insert           (void);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Load_Store_pointer_unit/src/Load_Store_pointer_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Load_Store_pointer_unit/src/Load_Store_pointer_unit.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Load_Store_pointer_unit/src/Load_Store_pointer_unit.cpp	(revision 131)
@@ -74,13 +74,16 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-
-	// Constant : accepted already transaction
-        for (uint32_t i=0; i<_param->_nb_front_end; ++i)
-          for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
-            {
-              internal_RETIRE_EVENT_ACK [i][j] = 1;
-              
-              PORT_WRITE(out_RETIRE_EVENT_ACK[i][j],internal_RETIRE_EVENT_ACK [i][j]);
-            }
+#ifdef SYSTEMCASS_SPECIFIC
+        constant();
+#else
+	log_printf(INFO,Load_Store_pointer_unit,FUNCTION,"Method - constant");
+
+	SC_METHOD (constant);
+// 	dont_initialize ();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+#endif
 
 	log_printf(INFO,Load_Store_pointer_unit,FUNCTION,"Method - transition");
